
-- RaidEye
-- Mac OS X Software RAID Monitor
-- 2006-2012 hanynet.com
-- by Hany El Imam - hany@hanynet.com
-- this is free software, NLPL License applies (www.nolicense.org)
-- this is a frontend for the raideyed daemon
-- raideyed C source code available at www.hanynet.com
--
-- version 2.2

property binaryPath : missing value -- PATH TO CURRENT APPLICATION BUNDLE
property alertStatus : missing value -- RAID FAILURE STATUS SWITCH
property idleStatus : missing value -- APPLICATION LOOP SWITCH
property theDelay : missing value -- APPLICATION LOOP TIME

-- clicked handler
on clicked theObject
	-- Click on ALERT windows
	if the name of theObject is equal to "kill" then -- STOP SOUND IN ALERT WINDOW
		set the visible of button "kill" of window "alert" to false as boolean
		try
			do shell script "killall raideyed" with administrator privileges --kill raideye daemon
		end try
		try
			do shell script "osascript -e 'tell application \"Disk Utility\" to activate'" --open disk utility.app
		end try
		set the visible of window "alert" to false as boolean
		set the visible of window "main" to true as boolean
		checkDaemon()
		-- quit app	
	else if the name of theObject is equal to "donate" then
		do shell script "open http://www.hanynet.com/donate.html"
	else if the name of theObject is equal to "closepanel" then -- ABORT CONFIGURATION
		set idleStatus to "idle"
		close panel (window of theObject)
	else if the name of theObject is equal to "quit" then -- ABORT INSTALLATION
		set the visible of window "install" to false as boolean
		quit
		-- start daemon
	else if the name of theObject is equal to "start" then -- MANUALLY START RAIDEYE DAEMON raideyed
		set idleStatus to "launching daemon"
		runDaemon()
	else if the name of theObject is equal to "install" then -- INSTALL RAIDEYE
		set the visible of button "install" of window "install" to false as boolean
		set the visible of button "quit" of window "install" to false as boolean
		installRaidEye()
	else if the name of theObject is equal to "saveconf" then -- CONFIGURE EMAIL SCRIPT
		configureEmail()
		--displayDialog("RaidEye email alerts configured.")
		close panel (window "email")
		display window "options" attached to window "main"
	else if the name of theObject is equal to "testconf" then -- CONFIGURE EMAIL SCRIPT AND SEND TEST EMAIL
		set the visible of progress indicator "spin" of window "main" to true as boolean
		set the enabled of button "saveconf" of window "email" to false as boolean
		configureEmail()
		try
			do shell script "python /usr/bin/raideyedemail.py" with administrator privileges
		on error errorText
			set the visible of progress indicator "spin" of window "main" to false as boolean
			displayDialog("Error sending test email")
		end try
		set the visible of progress indicator "spin" of window "main" to false as boolean
		set the visible of progress indicator "spin" of window "main" to false as boolean
		set the visible of progress indicator "spin" of window "main" to false as boolean
		displayDialog("Done.")
		set the enabled of button "testconf" of window "email" to true as boolean
		set the enabled of button "saveconf" of window "email" to true as boolean
	else if the name of theObject is equal to "saveconf2" then -- CONFIGURE TIMINGS /etc/raideyed.conf
		set the enabled of button "start" of window "main" to true as boolean
		set the visible of progress indicator "spin" of window "main" to false as boolean
		configureRaideye()
		set theDelay to do shell script "cat /etc/raideyed.conf |grep updateseconds |cut -d\"=\" -f2" -- parse conf file for loop time
		set idleStatus to "idle" -- START APP IDLE STATUS, LOOP
	else if the name of theObject is equal to "license" then
		close panel (window "license")
		display window "install" attached to window "main"
	else if the name of theObject is equal to "help" then -- OPEN PDF DOCS IN PREVIEW OR OTHER PDF READER
		do shell script "open \"" & binaryPath & "RaidEye.pdf\""
	end if
end clicked
--application launch
on awake from nib theObject -- WHAT HAPPENS AT APPLICATION LAUNCH
	set alertStatus to "noerrors" -- app doesn't idle and doesn't loop until alertStatus = "idle"
	-- get my path
	getPosixPath()
	--check if raideye is installed
	checkInstall()
	--check if daemon is running
	checkDaemon()
	--check appleraid volumes status
	checkRAID()
end awake from nib
--
-- get application path
on getPosixPath() -- GET POSIX PATH TO CURRENT APP
	set myPath to path to me as string
	set macPath to (myPath & "Contents:Resources:")
	set binaryPath to POSIX path of macPath
end getPosixPath
-----
on checkInstall() --CHECK IF RAIDEYE IS INSTALLED. IF NOT, SPAWN INSTALL INTERFACE AND INSTALL AND CONFIGURE EVERYTHING
	-- check for file existance
	set checkInstallResult to " "
	try
		do shell script "ls /etc/raideyed.conf"
	on error
		set checkInstallResult to "error"
	end try
	
	try
		do shell script "ls /Library/LaunchDaemons/com.hanynet.raideyed.plist"
	on error
		set checkInstallResult to "error"
	end try
	-- 
	try
		do shell script "ls /usr/bin/raideyed"
	on error
		set checkInstallResult to "error"
	end try
	--
	try
		do shell script "ls /usr/bin/raideyed.wav"
	on error
		set checkInstallResult to "error"
	end try
	--
	try
		do shell script "ls /Applications/RaidEye.app"
	on error
		set checkInstallResult to "error"
	end try
	--
	try
		do shell script "ls /usr/bin/raideyedemail.py"
	on error
		set checkInstallResult to "error"
	end try
	-------------
	if checkInstallResult is equal to "error" then
		-- raideye is not installed, install
		spawnInstall() -- START INSTALL SEQUENCE
	else
		-- raideye is installed: read loop time and start loop 
		try
			set theDelay to do shell script "cat /etc/raideyed.conf |grep updateseconds |cut -d\"=\" -f2"
		on error
			displayDialog("Error. You must reinstall RaidEye.")
		end try
		set idleStatus to "idle"
	end if
end checkInstall
--
on spawnInstall() -- START INSTALLING SEQUENCE
	try
		display window "license" attached to window "main"
		--set the visible of button "closepanel" of window "email" to false as boolean
		set the enabled of button "start" of window "main" to false as boolean
		set the visible of progress indicator "spin" of window "main" to true as boolean
		tell progress indicator "spin" of window "main" to start
	on error
		--
	end try
end spawnInstall
on installRaidEye() -- INSTALL EVERYTHING, INCLUDED RAIDEYE.APP IN /APPLICATIONS
	try
		do shell script "killall raideyed" with administrator privileges
	end try
	try
		do shell script "cp \"" & binaryPath & "raideyed.conf\" /etc/raideyed.conf" with administrator privileges
		-- /Library/LaunchDaemons/com.hanynet.raideye.plist
		do shell script "cp \"" & binaryPath & "com.hanynet.raideyed.plist\" /Library/LaunchDaemons/com.hanynet.raideyed.plist" with administrator privileges
		do shell script "chown root:wheel /Library/LaunchDaemons/com.hanynet.raideyed.plist" with administrator privileges
		do shell script "chmod 644 /Library/LaunchDaemons/com.hanynet.raideyed.plist" with administrator privileges
		-- /usr/bin/raideyed ,wav, email
		do shell script "cp \"" & binaryPath & "raideyed\" /usr/bin/raideyed" with administrator privileges
		do shell script "cp \"" & binaryPath & "raideyed.wav\" /usr/bin/raideyed.wav" with administrator privileges
		do shell script "cp \"" & binaryPath & "raideyedemail.py\" /usr/bin/raideyedemail.py" with administrator privileges
	on error errorCheck
		displayDialog("Error installing RaidEye: " & errorCheck)
		close panel (window "install")
		quit
	end try
	--
	set myPath to path to me as string
	set apppath to POSIX path of myPath
	try
		do shell script "cp -r \"" & apppath & "\" /Applications/RaidEye.app" with administrator privileges
	end try
	---
	displayDialog("RaidEye installed. RaidEye application frontend installed in /Applications directory. ")
	--
	close panel (window "install")
	set the contents of text field "computername" of window "email" to do shell script "systemsetup -getcomputername"
	display window "email" attached to window "main"
end installRaidEye

on uninstallRaidEye() -- REMOVE EVERYTHING AND KILL DAEMON 
	-- uninstall everything
	set idleStatus to "uninstalling"
	try
		do shell script "killall raideyed" with administrator privileges
	end try
	do shell script "rm -f /usr/bin/raideyed" with administrator privileges
	do shell script "rm -f /usr/bin/raideyed.wav" with administrator privileges
	do shell script "rm -f /usr/bin/raideyedemail.py" with administrator privileges
	do shell script "rm -f /Library/LaunchDaemons/com.hanynet.raideyed.plist" with administrator privileges
	do shell script "rm -f /etc/raideyed.conf" with administrator privileges
	do shell script "rm -rf /Applications/RaidEye.app" with administrator privileges
	displayDialog("RaidEye uninstalled: files removed, application trashed.")
	quit
end uninstallRaidEye

on configureEmail() -- CREATE PYTHON SCRIPT FOR EMAILS
	-- this is used to create /usr/bin/raideyedemail.py which is the python alert email script.
	tell progress indicator "spin" of window "email" to start
	set the visible of progress indicator "spin" of window "email" to true as boolean
	set gmailUser to the contents of text field "gmailuser" of window "email"
	set gmailPass to the contents of text field "gmailpass" of window "email"
	set gmailPass to ("" & gmailPass & "")
	set targetEmail to the contents of text field "destinationemail" of window "email"
	set bodyMsg to the contents of text field "computername" of window "email"
	-- remove temp script
	try
		do shell script "rm /usr/bin/raideyedemail.py.ok" with administrator privileges
	end try
	try
		-- restore script from bundle
		do shell script "cp \"" & binaryPath & "raideyedemail.py\" /usr/bin/raideyedemail.py" with administrator privileges
		-- parse and create new temp script
		do shell script "cat /usr/bin/raideyedemail.py |sed 's/fromaddr = \"\"/fromaddr = \"" & gmailUser & "\"/'g |sed 's/toaddr = \"\"/toaddr = \"" & targetEmail & "\"/'g | sed 's/password =/password = \"" & gmailPass & "\"/'g | sed 's/macinfo =/macinfo = \"" & bodyMsg & "\"/'g > /usr/bin/raideyedemail.py.ok" with administrator privileges
		-- copy new temp script to script
		do shell script "cp /usr/bin/raideyedemail.py.ok /usr/bin/raideyedemail.py" with administrator privileges
		-- remove temp script
		do shell script "rm /usr/bin/raideyedemail.py.ok" with administrator privileges
		set the visible of progress indicator "spin" of window "email" to false as boolean
	on error
		displayDialog("Invalid characters, please retry.")
		set the contents of text field "gmailuser" of window "email" to ""
		set the contents of text field "gmailpass" of window "email" to ""
		set the contents of text field "destinationemail" of window "email" to ""
		set the contents of text field "computername" of window "email" to ""
		return
	end try
end configureEmail
--
on configureRaideye() -- CREATE CONF FILE IN /ETC
	--set loop time in /etc/raideyed.conf
	set loopTime to the contents of text field "looptime" of window "options"
	set updateTime to the contents of text field "updatetime" of window "options"
	do shell script "cp \"" & binaryPath & "raideyed.conf\" /etc/raideyed.conf" with administrator privileges -- restore from bundle
	do shell script "cat /etc/raideyed.conf |sed 's/delayseconds=/delayseconds=" & loopTime & "/'g | sed 's/updateseconds=/updateseconds=" & updateTime & "/'g > /etc/raideyed.conf.ok" with administrator privileges
	do shell script "cp /etc/raideyed.conf.ok /etc/raideyed.conf" with administrator privileges
	do shell script "rm /etc/raideyed.conf.ok" with administrator privileges
	close panel (window "options")
	displayDialog("RaidEye configured. If the daemon is not running you can start it manually. The daemon will be loaded automatically at next system boot. ")
end configureRaideye
--
on checkDaemon() -- CHECK IF RAIDEYE DAEMON IS RUNNING AND GET ITS PID
	-- check for process "raideyed"
	set daemonCheck to do shell script "ps aux |grep raideyed |grep -v grep |awk '{print$2}'"
	if daemonCheck is equal to "" then
		set the contents of text field "daemonstatus" of window "main" to "Not running"
		set the visible of button "start" of window "main" to true as boolean
	else
		set the contents of text field "daemonstatus" of window "main" to "Running, PID " & daemonCheck
		set the visible of button "start" of window "main" to false as boolean
	end if
end checkDaemon
--
on runDaemon() -- LAUNCH DAEMON FROM APP THEN QUIT APP
	-- launch /usr/bin/raideyed in background with root privs
	displayDialog("RaidEye background daemon will be launched then RaidEye application will quit. ")
	set runRaidEyeDaemon to do shell script "killall RaidEye ; /usr/bin/raideyed && open /Applications/RaidEye.app" with administrator privileges
	quit
end runDaemon
--
on checkRAID() -- CHECK IF APPLERAID VOLUMES EXIST AND THEIR INTEGRITY STATUS
	try
		set checkForRAID to do shell script "diskutil listRAID"
	on error
		set checkForRAID to "No AppleRAID sets found"
	end try
	if checkForRAID is equal to "No AppleRAID sets found" then
		set checkResult to "No RAID found."
	else
		-- found an appleraid raid volume
		set checkResult to "Running, no errors"
		try
			set raidCheck1 to do shell script "diskutil listRAID |grep Missing | awk '{print $4}'"
			set raidCheck2 to do shell script "diskutil listRAID |grep Failed | awk '{print $4}'"
		end try
		if raidCheck1 is equal to "Missing/Damaged" then
			set checkResult to "Error! Missing or damaged disk"
			set the contents of text field "volumesstatus" of window "main" to checkResult
			if alertStatus is equal to "noerrors" then
				runAlert()
			end if
		end if
		if raidCheck2 is equal to "Failed" then
			set checkResult to "Error! A disk has failed"
			set the contents of text field "volumesstatus" of window "main" to checkResult
			if alertStatus is equal to "noerrors" then
				runAlert()
			end if
		end if
		--
	end if
	--
	set the contents of text field "volumesstatus" of window "main" to checkResult
end checkRAID

--
on updateGUI()
	-- set 2 text fields with volumes and daemon status
end updateGUI
--
on runAlert() -- SHOW ALERT WINDOW WHEN APP OPENS
	set alertStatus to "errors"
	set the visible of window "main" to false as boolean
	set the visible of window "alert" to true as boolean
end runAlert


-- dialog
on displayDialog(theMsg)
	try
		set theDialog to display dialog (theMsg) buttons {"OK"} default button 1 with icon 1
		set dialogReturn to "ok"
	on error
		set dialogReturn to "cancel"
	end try
end displayDialog



on launched theObject
	(*Add your script here.*)
end launched

on will finish launching theObject
	(*Add your script here.*)
end will finish launching
-- when app is idling loop to check daemon and raid volumes status and update raideye main window text fields
on idle theObject
	if idleStatus is equal to "idle" then
		checkDaemon()
		checkRAID()
		delay theDelay
	else
		--
	end if
end idle
--
on will quit theObject
	(*Add your script here.*)
end will quit

on choose menu item theObject -- CHOOSE ITEM FROM RAIDEYE MENU 
	if the name of theObject is equal to "uninstall" then
		set idleStatus to "uninstalling"
		uninstallRaidEye()
	else if the name of theObject is equal to "configureemail" then
		set idleStatus to "configure"
		set the visible of button "closepanel" of window "email" to true as boolean
		display window "email" attached to window "main"
	else if the name of theObject is equal to "donate" then
		do shell script "open http://www.hanynet.com/donate.html"
		
	end if
end choose menu item

on will close theObject
	set idleStatus to "quitting"
	quit
end will close





